// IEMozillaView.cpp : implementation of the CIEMozillaView class
//
/////////////////////////////////////////////////////////////////////////////
//
/**************************************************************
**        __                                          __
**     __/_/__________________________________________\_\__
**  __|_                                                  |__
** (___O)   William SerGio & Co., Inc.                   (O___)
**(_____O)	www.codearchive.com/~sergio			        (O_____)
**(_____O)	Author:	Bill SerGio, The Infomercial King   (O_____)
** (__O)	Author is listed in Who's Who in America     (O__)
**    |___________________________________________________|
****************************************************************/
/*
 * (C) Copyright 2002 by Bill SerGio, The Infomercial King.
 * All Rights Reserved Worldwide.
 * 20547 Old Cutler Road, PMB #222, Miami, FL 33189
 * www.codearchive.com/~sergio   sergio@codearchive.com  (305)233-9370
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted under this license for provided the following conditions are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Licensee does not utilize the software in a manner which is disparaging
 *    to the Author and/or any products or companies of the Author.
 * 4. This code/software may NOT be used in any way by any government,federal agency,
 *    or, any employee or agent of any government or federal agency. This software is
 *    not designed or intended for use in on-line control of aircraft, air traffic, 
 *    aircraft navigation or aircraft communications; or in design, construction, 
 *    operation or maintenance of any nuclear facility. Licensee represents and 
 *    warrants that it will not use or redistribute the Software for such purposes.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR FOR EDUCATIONAL PURPOSES ONLY,
 * 'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS,
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION),
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */


#include "stdafx.h"
#include "IEMozilla.h"
#include "IEMozillaDoc.h"
#include "MainFrm.h"
#include <docobj.h>

#include "IEMozillaView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CIEMozillaView

IMPLEMENT_DYNCREATE(CIEMozillaView, CView)

BEGIN_MESSAGE_MAP(CIEMozillaView, CView)
	//{{AFX_MSG_MAP(CIEMozillaView)
	ON_WM_CREATE()
	ON_COMMAND(ID_GO_BACK,				OnGoBack)
	ON_COMMAND(ID_GO_FORWARD,			OnGoForward)
	ON_COMMAND(ID_GO_STOP,				OnGoStop)
	ON_COMMAND(ID_GO_REFRESH,			OnGoRefresh)
	ON_COMMAND(ID_GO_START_PAGE,		OnGoStartPage)
	ON_COMMAND(ID_GO_SEARCH_THE_WEB,	OnGoSearchTheWeb)
	ON_COMMAND(ID_FILE_OPEN,			OnFileOpen)
	ON_WM_SIZE()
	ON_COMMAND(ID_FILE_PRINT,			OnFilePrint)
	ON_COMMAND(ID_VIEW_FONTS_LARGE,		OnViewFontsLarge)
	ON_COMMAND(ID_VIEW_FONTS_LARGEST,	OnViewFontsLargest)
	ON_COMMAND(ID_VIEW_FONTS_MEDIUM,	OnViewFontsMedium)
	ON_COMMAND(ID_VIEW_FONTS_SMALL,		OnViewFontsSmall)
	ON_COMMAND(ID_VIEW_FONTS_SMALLEST,	OnViewFontsSmallest)
	ON_COMMAND(ID_COOLEST_SITE, OnCoolestSite)
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



BEGIN_EVENTSINK_MAP(CIEMozillaView, CView)
    //{{AFX_EVENTSINK_MAP(CIEMozilla)
	ON_EVENT(CIEMozillaView, IDX_BROWSER, 102 /* StatusTextChange */, OnStatusTextChange, VTS_BSTR)
	ON_EVENT(CIEMozillaView, IDX_BROWSER, 108 /* ProgressChange */, OnProgressChange, VTS_I4 VTS_I4)
	ON_EVENT(CIEMozillaView, IDX_BROWSER, 105 /* CommandStateChange */, OnCommandStateChange, VTS_I4 VTS_BOOL)
	ON_EVENT(CIEMozillaView, IDX_BROWSER, 106 /* DownloadBegin */, OnDownloadBegin, VTS_NONE)
	ON_EVENT(CIEMozillaView, IDX_BROWSER, 104 /* DownloadComplete */, OnDownloadComplete, VTS_NONE)
	ON_EVENT(CIEMozillaView, IDX_BROWSER, 113 /* TitleChange */, OnTitleChange, VTS_BSTR)
	ON_EVENT(CIEMozillaView, IDX_BROWSER, 112 /* PropertyChange */, OnPropertyChange, VTS_BSTR)
	ON_EVENT(CIEMozillaView, IDX_BROWSER, 250 /* BeforeNavigate2 */, OnBeforeNavigate2, VTS_DISPATCH VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PBOOL)
	ON_EVENT(CIEMozillaView, IDX_BROWSER, 251 /* NewWindow2 */, OnNewWindow2, VTS_PDISPATCH VTS_PBOOL)
	ON_EVENT(CIEMozillaView, IDX_BROWSER, 252 /* NavigateComplete2 */, OnNavigateComplete2, VTS_DISPATCH VTS_PVARIANT)
	ON_EVENT(CIEMozillaView, IDX_BROWSER, 259 /* DocumentComplete */, OnDocumentComplete, VTS_DISPATCH VTS_PVARIANT)
	ON_EVENT(CIEMozillaView, IDX_BROWSER, 253 /* OnQuit */, OnOnQuit, VTS_NONE)
	ON_EVENT(CIEMozillaView, IDX_BROWSER, 254 /* OnVisible */, OnOnVisible, VTS_BOOL)
	ON_EVENT(CIEMozillaView, IDX_BROWSER, 255 /* OnToolBar */, OnOnToolBar, VTS_BOOL)
	ON_EVENT(CIEMozillaView, IDX_BROWSER, 256 /* OnMenuBar */, OnOnMenuBar, VTS_BOOL)
	ON_EVENT(CIEMozillaView, IDX_BROWSER, 257 /* OnStatusBar */, OnOnStatusBar, VTS_BOOL)
	ON_EVENT(CIEMozillaView, IDX_BROWSER, 258 /* OnFullScreen */, OnOnFullScreen, VTS_BOOL)
	ON_EVENT(CIEMozillaView, IDX_BROWSER, 260 /* OnTheaterMode */, OnOnTheaterMode, VTS_BOOL)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()


/////////////////////////////////////////////////////////////////////////////
// CIEMozillaView construction/destruction

CIEMozillaView::CIEMozillaView()
{
	// TODO: add construction code here

}

CIEMozillaView::~CIEMozillaView()
{
}

BOOL CIEMozillaView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CIEMozillaView drawing

void CIEMozillaView::OnDraw(CDC* pDC)
{
	CIEMozillaDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CIEMozillaView diagnostics

#ifdef _DEBUG
void CIEMozillaView::AssertValid() const
{
	CView::AssertValid();
}

void CIEMozillaView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CIEMozillaDoc* CIEMozillaView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CIEMozillaDoc)));
	return (CIEMozillaDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CIEMozillaView message handlers

int CIEMozillaView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	if ( ! m_Browser.Create( NULL, WS_CHILD | WS_VISIBLE, CRect(), this, IDX_BROWSER ) )
		return -1;
	/*
	if ( g_Global.m_bMozilla ) 
	{
		m_Browser.Navigate("about", &vtEmpty, &vtEmpty, &vtEmpty, &vtEmpty);
	}
	else
	{
		m_Browser.Navigate("about:<h1>Microsoft's%20WebBrowser%20ActiveX%20Control<h1>", &vtEmpty, &vtEmpty, &vtEmpty, &vtEmpty);
	}
	*/
	return 0;
}

void CIEMozillaView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
	
	// TODO: Add your specialized code here and/or call the base class

	CDocument* pDoc = GetDocument();

	CString strPath;
	strPath = ResourceToURL(_T("HTML_INTRO"));  // For IE only!
	
	if ( g_Global.m_bMozilla ) 
	{
		// Must copy resource out to a file or load stream!!!
		m_Browser.Navigate("http://www.mozilla.org/", &vtEmpty, &vtEmpty, &vtEmpty, &vtEmpty);
	}
	else
	{
		m_Browser.Navigate("www.codearchive.com/~sergio", &vtEmpty, &vtEmpty, &vtEmpty, &vtEmpty);
	}

}

/**
 * AUTHOR: BILL SERGIO
 * VERY COOL...
 * Notice below that we MUST push non-client borders 
 * out of client area which prpgrammers forget to do!!!
 *
 * This code shows how the WebBrowser control would
 * normally be resized when client window is resized. 
 * Call to UpdateWindow() causes a WM_PAINT message 
 * to be sent directly to the window of the control. 
 */
void CIEMozillaView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	if (::IsWindow(m_Browser.m_hWnd))
	{
		CRect rect;
		GetClientRect(rect);

		// Very cool
		// MUST push non-client borders out of client area!!!
		//
		if ( !g_Global.m_bMozilla ) 
		{
			::AdjustWindowRectEx(rect, m_Browser.GetStyle(), FALSE, WS_EX_CLIENTEDGE);
		}
		m_Browser.SetWindowPos(NULL, rect.left, rect.top,
			rect.Width(), rect.Height(), SWP_NOACTIVATE | SWP_NOZORDER);
	}
}

void CIEMozillaView::OnGoBack() 
{
	// TODO: Add your command handler code here
	m_Browser.GoBack();	
}

void CIEMozillaView::OnGoForward() 
{
	// TODO: Add your command handler code here
	m_Browser.GoForward();
}


void CIEMozillaView::OnGoStop() 
{
	// TODO: Add your command handler code here
	m_Browser.Stop();
}

void CIEMozillaView::OnGoRefresh() 
{
	// TODO: Add your command handler code here
	m_Browser.Refresh();
}


void CIEMozillaView::OnGoSearchTheWeb() 
{
	// TODO: Add your command handler code here
	//m_Browser.Refresh();
}


void CIEMozillaView::OnGoStartPage() 
{
	// TODO: Add your command handler code here
	//m_Browser.Refresh();
}



void CIEMozillaView::LoadBrowser(CString sUrl)
{
	try
	{
		// REQUIRES FULL PATHWAY ON DRIVE OR URL
		COleVariant vaURL(sUrl);
		m_Browser.Navigate2(vaURL, &vtEmpty, &vtEmpty, &vtEmpty, &vtEmpty);
	}
	catch( ... ) {}

}


////////////////////////////////////////////////////////
//////////////////// FONT METHODS //////////////////////
////////////////////////////////////////////////////////
void CIEMozillaView::UpdateFontMenu(UINT uItemToCheck)
{
	CMenu* pMenu = AfxGetMainWnd()->GetMenu();
	if (pMenu)
	{
		pMenu->CheckMenuItem(uItemToCheck, MF_CHECKED);
		pMenu->CheckMenuItem(m_uChecked, MF_UNCHECKED);
		m_uChecked = uItemToCheck;
	}

}

void CIEMozillaView::OnViewFontsLarge()
{
	COleVariant vaZoomFactor(4l);

	m_Browser.ExecWB(OLECMDID_ZOOM, OLECMDEXECOPT_DONTPROMPTUSER, &vaZoomFactor, NULL);

	/*
	if (ID_VIEW_FONTS_LARGE != m_uChecked)
	{
		ChangeScale(IESS_Large);
		UpdateFontMenu(ID_VIEW_FONTS_LARGE);
	}
	*/
}

void CIEMozillaView::OnViewFontsLargest()
{
	if (ID_VIEW_FONTS_LARGEST != m_uChecked)
	{
		ChangeScale(IESS_Largest);
		UpdateFontMenu(ID_VIEW_FONTS_LARGEST);
	}
}

void CIEMozillaView::OnViewFontsMedium() 
{
	if (ID_VIEW_FONTS_MEDIUM != m_uChecked)
	{
		ChangeScale(IESS_Medium);
		UpdateFontMenu(ID_VIEW_FONTS_MEDIUM);
	}
}

void CIEMozillaView::OnViewFontsSmall() 
{
	if (ID_VIEW_FONTS_SMALL != m_uChecked)
	{
		ChangeScale(IESS_Small);
		UpdateFontMenu(ID_VIEW_FONTS_SMALL);\
	}
}

void CIEMozillaView::OnViewFontsSmallest() 
{
	if (ID_VIEW_FONTS_SMALLEST != m_uChecked)
	{
		ChangeScale(IESS_Smallest);
		UpdateFontMenu(ID_VIEW_FONTS_SMALLEST);
	}
}

void CIEMozillaView::ChangeScale(IEScaleSize scaleSize)
{
	HRESULT hr;

	LPDISPATCH pDisp = NULL;
	LPOLECOMMANDTARGET pCmdTarg = NULL;

	//if (!m_Browser.m_hWnd)
	//{
	//	TRACE("Web Browser Control not yet created.\n");
	//	return;
	//}

	pDisp = m_Browser.GetDocument();

	if (!pDisp)
	{
		TRACE("Unable to get document from Web Browser.\n");
		return;
	}

	// The document controls the availability of commands items, 
	// so get the OLE command target interface from the document
	hr = pDisp->QueryInterface(IID_IOleCommandTarget, (LPVOID*)&pCmdTarg);
	if (pCmdTarg)
	{
	// Now use the command target to do something useful like (un-)zoom the page
		OLECMD rgCmd[1] = {{OLECMDID_ZOOM, 0}}; 
		// Is the command available for execution?
		hr = pCmdTarg->QueryStatus(NULL, 1, rgCmd, NULL);

		if (SUCCEEDED(hr) && OLECMDF_ENABLED == rgCmd[0].cmdf)
		{

			TRACE("Zoom enabled.\n");
			VARIANT vaZoomFactor;	// Input arguments
			VariantInit(&vaZoomFactor);
			V_VT(&vaZoomFactor) = VT_I4;
			V_I4(&vaZoomFactor) = scaleSize;
			hr = pCmdTarg->Exec(NULL, OLECMDID_ZOOM, 
						OLECMDEXECOPT_DONTPROMPTUSER, 
						&vaZoomFactor, NULL);
			VariantClear(&vaZoomFactor);
		}
		else
		{
			TRACE("Unable to query for status of command (OLECMDID_ZOOM).\n");
		}
	}
	else
	{
		TRACE("Unable to get command target from Web Browser document.\n");
	}

	if (pCmdTarg) pCmdTarg->Release(); // release reference to document's command target

	if (pDisp) pDisp->Release(); // release the document's dispatch interface
}

////////////////////////////////////////////////////////
//////////////////// END OF FONT METHODS ///////////////
////////////////////////////////////////////////////////



// This shows how to use Navigate2() function to load local files 
// including local HTML pages, GIFs, AIFF files, etc.
//
void CIEMozillaView::OnFileOpen()
{
	CString str;

	str.LoadString(IDS_FILETYPES);

	CFileDialog fileDlg(TRUE, NULL, NULL, OFN_HIDEREADONLY, str);

	if(fileDlg.DoModal() == IDOK)
		LoadBrowser(fileDlg.GetPathName());
}




void CIEMozillaView::OnFilePrint() 
{
	// get the HTMLDocument

	//if (m_pBrowserApp != NULL)
	//{
		LPOLECOMMANDTARGET lpTarget = NULL;
		LPDISPATCH lpDisp = m_Browser.GetDocument();

		if (lpDisp != NULL)
		{
			// the control will handle all printing UI

			if (SUCCEEDED(lpDisp->QueryInterface(IID_IOleCommandTarget,
					(LPVOID*) &lpTarget)))
			{
				lpTarget->Exec(NULL, OLECMDID_PRINT, 0, NULL, NULL);
				lpTarget->Release();
			}
			lpDisp->Release();
		}
	//}
}


// AUTHOR: Bill SerGio, The Infomercial King
// Printing Notes:
//
// IWebBrowser2::ExecWB is a wrapper for the Exec method of 
// the IOleCommandTarget interface. The ExecWB method has the
// following signature: 
/*
HRESULT ExecWB(
    OLECMDID cmdID,
    OLECMDEXECOPT cmdexecopt,
    VARIANT *pvaIn,
    VARIANT *pvaOut
);

  When you use an OLECMDID enumeration of the OLECMDID_PRINT 
  element with ExecWB , you can specify extended printing 
  information by passing in the SAFEARRAY structure through 
  the VARIANT argument pvaIn. This SAFEARRAY data type takes
  a maximum of five items: 
  
	A string (BSTR) that contains a custom header. 
	A string (BSTR) that contains a custom footer. 
	An IStream object that contains an HTML file that
	serves as an "optional header." This is the e-mail 
	header that you see in Microsoft Outlook and Microsoft 
	Outlook Express e-mail messages when you print them. 
	This IStream must point to a full, valid HTML document,
	not HTML fragments, or it will print incorrectly. 
	An alternative URL to use for the document. 
	This is only relevant to Outlook and Outlook Express. 
	A set of printing flags (dwFlags) to configure printer. 
	This is only relevant to Outlook and Outlook Express. 
	Here is an event handler for a Print menu command in 
	a Visual C++ WebBrowser host.  
*/
/*
LRESULT CIEMozillaView::OnPrint(WORD wNotifyCode, 
								WORD wID, 
								HWND hWndCtl, 
								BOOL& bHandled) 
{
	SAFEARRAYBOUND psabBounds[1];
	SAFEARRAY *psaHeadFoot;
	HRESULT hr = S_OK;

	// Variables needed to send IStream header to print operation.
	HGLOBAL hG = 0;
	IStream *pStream= NULL;
	IUnknown *pUnk = NULL;
	ULONG lWrote = 0;
	LPSTR sMem = NULL;
	
	if (! m_Browser.GetHwnd()) {
		TRACE(_T("DoPrint: Cannot print - WebBrowser control not ready\n"));
		goto cleanup;
	}
	
	// Initialize header and footer parameters to send to ExecWB().
	psabBounds[0].lLbound = 0;
	psabBounds[0].cElements = 3;
	psaHeadFoot = SafeArrayCreate(VT_VARIANT, 1, psabBounds);
	if (NULL == psaHeadFoot) {
		// Error handling goes here.
		goto cleanup;
	}
	VARIANT vHeadStr, vFootStr, vHeadTxtStream;
	long rgIndices;
	VariantInit(&vHeadStr);
	VariantInit(&vFootStr);
	VariantInit(&vHeadTxtStream);

	// Argument 1: Header
	vHeadStr.vt = VT_BSTR;
	vHeadStr.bstrVal = SysAllocString(L"This is my header string.");
	if (vHeadStr.bstrVal == NULL) {
		goto cleanup;
	}
	
	// Argument 2: Footer
	vFootStr.vt = VT_BSTR;
	vFootStr.bstrVal = SysAllocString(L"This is my footer string.");
	if (vFootStr.bstrVal == NULL) {
		TRACE(_T("DoPrint: Could not allocate memory in %s: Line %d\n"), __FILE__, __LINE__);
		goto cleanup;
	}

	// Argument 3: IStream containing header text. Outlook and Outlook 
         // Express use this to print out the mail header. 	
	if ((sMem = (LPSTR)CoTaskMemAlloc(512)) == NULL) {
		TRACE(_T("DoPrint: Could not allocate memory in %s: Line %d\n"), __FILE__, __LINE__);
		goto cleanup;
	}
	// We must pass in a full HTML file here, otherwise this 
         // gets turned into garbage corrupted when we print.
	sprintf(sMem, "<html><body><strong>Printed By:</strong> Custom WebBrowser Host 1.0<p></body></html>\0");

	// Allocate an IStream for the LPSTR that we just created.
	hG = GlobalAlloc(GMEM_FIXED | GMEM_ZEROINIT, strlen(sMem));
	if (hG == NULL) {
		TRACE(_T("DoPrint: Could not allocate memory in %s: Line %d\n"), __FILE__, __LINE__);
		goto cleanup;
	}
	hr = CreateStreamOnHGlobal(hG, TRUE, &pStream);
	if (FAILED(hr)) {
		TRACE(_T("OnPrint::Failed to create stream from HGlobal: %lX\n"), hr);
		goto cleanup;
	}
	hr = pStream->Write(sMem, strlen(sMem), &lWrote);
	if (SUCCEEDED(hr)) {
	    // Set the stream back to its starting position.
		LARGE_INTEGER pos;
		pos.QuadPart = 0;
		pStream->Seek((LARGE_INTEGER)pos, STREAM_SEEK_SET, NULL);
		hr = pStream->QueryInterface(IID_IUnknown, reinterpret_cast<void **>(&pUnk));
		vHeadTxtStream.vt = VT_UNKNOWN;
		vHeadTxtStream.punkVal = pUnk;
	}

	rgIndices = 0;
	SafeArrayPutElement(psaHeadFoot, &rgIndices, static_cast<void *>(&vHeadStr));
	rgIndices = 1;
	SafeArrayPutElement(psaHeadFoot, &rgIndices, static_cast<void *>(&vFootStr));
	rgIndices = 2;
	SafeArrayPutElement(psaHeadFoot, &rgIndices, static_cast<void *>(&vHeadTxtStream));
		
	// SAFEARRAY must be passed ByRef or else MSHTML 
	// transforms it into NULL.
	VARIANT vArg;
	VariantInit(&vArg);
	vArg.vt = VT_ARRAY | VT_BYREF;
	vArg.parray = psaHeadFoot;
	
	m_Browser.ExecWB(OLECMDID_PRINT, OLECMDEXECOPT_DONTPROMPTUSER, &vArg, NULL);
	//if (FAILED(hr)) {
	//	TRACE(_T("DoPrint: Call to WebBrowser's ExecWB failed: %lX\n"), hr);
	//goto cleanup;

	//WebBrowser control will clean up the SAFEARRAY after printing.
	return 1; 

cleanup:
	VariantClear(&vHeadStr);
	VariantClear(&vFootStr);
	VariantClear(&vHeadTxtStream);
	if (psaHeadFoot) {
		SafeArrayDestroy(psaHeadFoot);
	}
	if (sMem) {
		CoTaskMemFree(sMem);	
	}
	if (hG != NULL) {
		GlobalFree(hG);
	}
	if (pStream != NULL) {
		pStream->Release();
		pStream = NULL;
	}
	bHandled = TRUE;
	return 0;
}
*/

///////////////////////////////////////////////////
/////////////// SINK EVENTS ///////////////////////
///////////////////////////////////////////////////
void CIEMozillaView::OnStatusTextChange(LPCTSTR Text) 
{
}

void CIEMozillaView::OnProgressChange(long Progress, long ProgressMax) 
{
}

void CIEMozillaView::OnCommandStateChange(long Command, BOOL Enable) 
{
}

void CIEMozillaView::OnDownloadBegin() 
{
}

void CIEMozillaView::OnDownloadComplete() 
{
}

void CIEMozillaView::OnTitleChange(LPCTSTR lpszText) 
{
	// this will change the main frame's title bar
	if (m_pDocument != NULL){
		lpszText = "Bill SerGio's Mozilla Browser";
		m_pDocument->SetTitle(lpszText);
	}
}

void CIEMozillaView::OnPropertyChange(LPCTSTR szProperty) 
{
}

void CIEMozillaView::OnBeforeNavigate2(LPDISPATCH pDisp,
									 VARIANT FAR* URL,
									 VARIANT FAR* Flags,
									 VARIANT FAR* TargetFrameName, 
									 VARIANT FAR* PostData,
									 VARIANT FAR* Headers,
									 BOOL FAR* Cancel) 
{
	/*
	ASSERT(V_VT(URL) == VT_BSTR);
	ASSERT(V_VT(TargetFrameName) == VT_BSTR);
	ASSERT(V_VT(PostData) == (VT_VARIANT | VT_BYREF));
	ASSERT(V_VT(Headers) == VT_BSTR);
	ASSERT(Cancel != NULL);

	USES_CONVERSION;

	VARIANT* vtPostedData = V_VARIANTREF(PostData);
	CByteArray array;
	if (V_VT(vtPostedData) & VT_ARRAY)
	{
		// must be a vector of bytes
		ASSERT(vtPostedData->parray->cDims == 1 && vtPostedData->parray->cbElements == 1);

		vtPostedData->vt |= VT_UI1;
		COleSafeArray safe(vtPostedData);

		DWORD dwSize = safe.GetOneDimSize();
		LPVOID pVoid;
		safe.AccessData(&pVoid);

		array.SetSize(dwSize);
		LPBYTE lpByte = array.GetData();

		memcpy(lpByte, pVoid, dwSize);
		safe.UnaccessData();
	}
	// Make real parameters out of notification shit

	CString strTargetFrameName(V_BSTR(TargetFrameName));
	CString strURL = V_BSTR(URL);
	CString strHeaders = V_BSTR(Headers);
	DWORD nFlags = V_I4(Flags);
	*/

	// Retrieve data as a string from a POST
	if (PostData != NULL && PostData->vt == (VT_VARIANT|VT_BYREF) && 
		PostData->pvarVal->vt != VT_EMPTY )
	{		
		// Author: Bill SerGio, The Infomercial King
		// If you use "StrCpyN" below you MUST add:
		// Header: Declared in shlwapi.h
		// Import Library: shlwapi.lib
		/*
		
		*Cancel = TRUE;
		char *szTemp = NULL, *szPostData = NULL;
		long plLbound, plUbound;
		
		SAFEARRAY *parrTemp = PostData -> pvarVal->parray;
		SafeArrayAccessData(parrTemp , (void HUGEP **) &szTemp);
		
		SafeArrayGetLBound(parrTemp , 1, &plLbound);
		SafeArrayGetUBound(parrTemp , 1, &plUbound);
		
		szPostData = new char[plUbound - plLbound + 2];
	         StrCpyN(szPostData, szTemp, plUbound - plLbound + 1);
		szPostData[plUbound-plLbound] = '\0';
		SafeArrayUnaccessData(parrTemp);

		// Do something here with posted data!
		//MessageBox(szPostData);
		
		delete[] parrTemp;
		delete[] szTemp;
		delete[] szPostData;
		*/
	}
	// Retrieve data from a Navigate to URL
	try
	{
		csTestUrl = (CString)URL->bstrVal;
		AfxExtractSubString(csEvent, csTestUrl, 0, (TCHAR)':');
		AfxExtractSubString(csAction, csTestUrl, 1, (TCHAR)':');
		AfxExtractSubString(csData, csTestUrl, 2, (TCHAR)':');
		AfxExtractSubString(csQuestionMark, csTestUrl, 1, (TCHAR)'?');
	}
	catch(...) {}
	csEvent.MakeUpper();

	if ( csEvent != "EVENT" ) { }
	else {
		try {
			csAction.MakeUpper();
			if (csAction == "DRAG")
			{
				*Cancel = TRUE;
				//if (WM_LBUTTONDOWN && HTCLIENT && !::IsZoomed(GetSafeHwnd())){}
				ReleaseCapture();
				::SendMessage(GetSafeHwnd(),WM_NCLBUTTONDOWN,HTCAPTION,NULL);
				//AfxGetApp()->OnIdle(0);   // updates user interface
			}
		}
		catch( ... ) { *Cancel = TRUE; }
	}
}

void CIEMozillaView::OnNewWindow2(LPDISPATCH FAR* ppDisp, BOOL FAR* Cancel) 
{
}

void CIEMozillaView::OnNavigateComplete2(LPDISPATCH pDisp, VARIANT FAR* URL) 
{
   /**
	* AUTHOR: BILL SERGIO
	* WARNING: LPDISPATCH glpDisp = NULL; 
	* global LPDISPATCH, MUST be of class scope ONLY!!!
	* because we have multiple instances of this skin class!!!
	* Check if glpDisp is NULL which means it is top level NavigateComplete2. 
	* Save LPDISPATCH
	*/
    if (!glpDisp)
		glpDisp = pDisp;
}

/**
 * AUTHOR: BILL SERGIO
 * IMPORTANT INFO ON USING WEB BROWSER CONTROL
 * WebBrowser control fires DocumentComplete event when its ReadyState property 
 * is changed to READYSTATE_COMPLETE. This indicates that WebBrowser control 
 * has completed downloading a Web page. In case of page with no frames, 
 * DocumentComplete is fired once after everything is done. In case of multiple 
 * frames, DocumentComplete gets fired multiple times. Not every frame fires this
 * event, but each frame that fires a DownloadBegin event fires a corresponding 
 * DocumentComplete event. The DocumentComplete event has a IDispatch* parameter, 
 * which is the IDispatch of the frame (shdocvw) for which DocumentComplete is fired. 
 * The top-level frame fires the DocumentComplete in the end. So, to check if a page 
 * is done downloading, you need to check if the IDispatch* parameter is same as the
 * IDispatch of the WebBrowser control. 
 * If navigation occurs within a frame itself, then final DocumentComplete fired is 
 * that of frame and not top-level frame. If WebBrowser control is hosting a 
 * frameset, and within one frame of the frameset, the user clicks on a link that 
 * opens a new page in the frame itself and keeps the rest of the frameset intact. 
 * Then new page could contain multiple frames again, and there will be multiple 
 * DocumentComplete notifications (one for each new frame). Since the top-level frame
 * has not changed, final DocumentComplete would be that of the frame that has changed. 
 * The solution I implement here is to check if the IDispatch parameter of the
 * DocumentComplete is the same as the IDispatch parameter of first NavigateComplete2
 * event. Since first NavigateComplete2 is of the top-level frame and last 
 * DocumentComplete is also of the top-level frame, doing a comparison in such a 
 * fashion will tell whether the page is done downloading. 
 */
void CIEMozillaView::OnDocumentComplete(LPDISPATCH pDisp, VARIANT FAR* URL) 
{   
	try{
 		if (glpDisp && glpDisp == pDisp){
			CString strUrl = (CString)URL->bstrVal;
			glpDisp = NULL;

			((CMainFrame*)GetParentFrame())->SetAddress(strUrl);

		}//(glpDisp && glpDisp == pDisp)	
	}
	catch( ... ){return;}
}


void CIEMozillaView::OnOnQuit() 
{
}

void CIEMozillaView::OnOnVisible(BOOL Visible) 
{
}

void CIEMozillaView::OnOnToolBar(BOOL ToolBar) 
{
}

void CIEMozillaView::OnOnMenuBar(BOOL MenuBar) 
{
}

void CIEMozillaView::OnOnStatusBar(BOOL StatusBar) 
{
}

void CIEMozillaView::OnOnFullScreen(BOOL FullScreen) 
{
}

void CIEMozillaView::OnOnTheaterMode(BOOL TheaterMode) 
{
}


/**
 * AUTHOR: Bill SerGio, The Infomercial King
 * When the Web Browser control is embedded in a CView or CWnd 
 * class, keystrokes do not work properly:
 *
 * Tabbing between HTML elements does not work properly. 
 * Cannot type text in HTML input fields. You can see the 
 * carat but cannot type any characters 
 * CView and Wnd classes do not carry the additional overhead
 * necessary to forward keyboard messages to children for 
 * processing. It is necessary to add this functionality to 
 * your derived class by using PreTranslateMessage.
 */
BOOL CIEMozillaView::PreTranslateMessage(MSG* pMsg)
{
   if (IsDialogMessage(pMsg))
       return TRUE;
   else
       return CWnd::PreTranslateMessage(pMsg);
}

/*
// Scroll window
// m_Browser is CIEMozillaView class
IDispatch *pDisp = m_Browser.GetHtmlDocument();

IHTMLDocument2 *pDocument = NULL;
pDisp->QueryInterface( IID_IHTMLDocument2, ( void** )&pDocument );

IHTMLElement* pBody = NULL;
pDocument->get_body( &pBody );

IHTMLWindow2* pWindow = NULL;
pDocument->get_parentWindow( &pWindow );

pWindow->scroll( 0, 250 );
*/

/*
HRESULT CIEMozillaView::LoadWebBrowserFromStream(IWebBrowser* pWebBrowser, IStream* pStream)
{
	HRESULT hr;
	IDispatch* pHtmlDoc = NULL;
	IPersistStreamInit* pPersistStreamInit = NULL;

    // Retrieve the document object.
    hr = pWebBrowser->get_Document( &pHtmlDoc );
    if ( SUCCEEDED(hr) )
    {
        // Query for IPersistStreamInit.
        hr = pHtmlDoc->QueryInterface( IID_IPersistStreamInit,  (void**)&pPersistStreamInit );
        if ( SUCCEEDED(hr) )
        {
            // Initialize the document.
            hr = pPersistStreamInit->InitNew();
            if ( SUCCEEDED(hr) )
            {
                // Load the contents of the stream.
                hr = pPersistStreamInit->Load( pStream );
            }
            pPersistStreamInit->Release();
        }
    }
}
*/

/*
copy document to clipboard
void CIEMozillaView::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else if ((nID & 0xFFF0) == IDM_BROWSERCOPY)
	{
		LPDISPATCH lpDispatch = NULL;
		LPOLECOMMANDTARGET lpOleCommandTarget = NULL;
		CWebBrowser* pWeb = (CWebBrowser*)GetDlgItem(IDC_EXPLORER1);

		lpDispatch = pWeb->GetDocument();
		ASSERT(lpDispatch);

		lpDispatch->QueryInterface(IID_IOleCommandTarget,
						(void**)&lpOleCommandTarget);
		ASSERT(lpOleCommandTarget);

		lpDispatch->Release();

		lpOleCommandTarget->
				Exec(NULL,OLECMDID_COPY,NULL,NULL,NULL);

		lpOleCommandTarget->Release();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}


void CIEMozillaView::OnCommandStateChangeExplorer1(long Command, BOOL Enable) 
{
	switch(Command)
	{
	case CSC_NAVIGATEFORWARD:
		{
		CButton *pButton = (CButton*)g_pDlg->GetDlgItem(IDC_BT_FORWARD);
		pButton->EnableWindow(Enable);
		}
		break;
	case CSC_NAVIGATEBACK:
		{
		CButton *pButton = (CButton*)g_pDlg->GetDlgItem(IDC_BT_BACK);
		pButton->EnableWindow(Enable);
		}
		break;
	default:
		break;
	}
}


*/

void CIEMozillaView::OnCoolestSite() 
{
	// TODO: Add your command handler code here
	
}


CString CIEMozillaView::ResourceToURL(LPCTSTR lpszURL)
{
	// This functions shows how to convert an URL to point
	// within the application
	// I only use it once to get the startup page

	CString m_strURL;
	HINSTANCE hInstance = AfxGetResourceHandle();
	ASSERT(hInstance != NULL);
	
	LPTSTR lpszModule = new TCHAR[_MAX_PATH];
	
	if (GetModuleFileName(hInstance, lpszModule, _MAX_PATH))
	{
		m_strURL.Format(_T("res://%s/%s"), lpszModule, lpszURL);
	}
	
	delete []lpszModule;

	return m_strURL;
}


BOOL CIEMozillaView::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Add your message handler code here and/or call default
	
	//return CView::OnEraseBkgnd(pDC);
	return TRUE;

}
