// IEMozillaView.h : interface of the CIEMozillaView class
//
/////////////////////////////////////////////////////////////////////////////
//
/**************************************************************
**        __                                          __
**     __/_/__________________________________________\_\__
**  __|_                                                  |__
** (___O)   William SerGio & Co., Inc.                   (O___)
**(_____O)	www.codearchive.com/~sergio			        (O_____)
**(_____O)	Author:	Bill SerGio, The Infomercial King   (O_____)
** (__O)	Author is listed in Who's Who in America     (O__)
**    |___________________________________________________|
****************************************************************/
/*
 * (C) Copyright 2002 by Bill SerGio, The Infomercial King.
 * All Rights Reserved Worldwide.
 * 20547 Old Cutler Road, PMB #222, Miami, FL 33189
 * www.codearchive.com/~sergio   sergio@codearchive.com  (305)233-9370
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted under this license for provided the following conditions are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Licensee does not utilize the software in a manner which is disparaging
 *    to the Author and/or any products or companies of the Author.
 * 4. This code/software may NOT be used in any way by any government,federal agency,
 *    or, any employee or agent of any government or federal agency. This software is
 *    not designed or intended for use in on-line control of aircraft, air traffic, 
 *    aircraft navigation or aircraft communications; or in design, construction, 
 *    operation or maintenance of any nuclear facility. Licensee represents and 
 *    warrants that it will not use or redistribute the Software for such purposes.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR FOR EDUCATIONAL PURPOSES ONLY,
 * 'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS,
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION),
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */


#if !defined(AFX_IEMOZILLAVIEW_H__7A739621_F300_11D1_9F48_C49E4E07811D__INCLUDED_)
#define AFX_IEMOZILLAVIEW_H__7A739621_F300_11D1_9F48_C49E4E07811D__INCLUDED_

#include "webbrowser2.h"	// Added by ClassView
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

enum IEScaleSize {IESS_Smallest, IESS_Small, IESS_Medium, IESS_Large, IESS_Largest};


class CIEMozillaView : public CView
{
protected: // create from serialization only
	CIEMozillaView();
	DECLARE_DYNCREATE(CIEMozillaView)

// Attributes
public:
	CIEMozillaDoc* GetDocument();

	CString ResourceToURL(LPCTSTR lpszURL);

	COleVariant vtEmpty;

	// OnBeforeNavigate2 variables
	CString		csTestUrl;
	CString		csEvent;
	CString		csAction;
	CString		csData;
	CString		csQuestionMark;

	// OnDocumentComplete variables
	LPDISPATCH	glpDisp;
	BOOL		bUranusRgnHide;		// Hide if no <TITLE>URANUS:rgn</TITLE>
	BOOL		bShowDlg;			// Show or Hide Dialog

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CIEMozillaView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual void OnInitialUpdate();
	//}}AFX_VIRTUAL

// Implementation
public:
	void LoadBrowser(CString sUrl);
	CWebBrowser2 m_Browser;
	virtual ~CIEMozillaView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	void ChangeScale(IEScaleSize scaleSize = IESS_Smallest);
	void UpdateFontMenu(UINT uItemToCheck);
	UINT m_uChecked;

	//LRESULT OnPrint(WORD wNotifyCode, 
	//				WORD wID, 
	//				HWND hWndCtl, 
	//				BOOL& bHandled);

// Generated message map functions
protected:
	//{{AFX_MSG(CIEMozillaView)
	afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnGoBack();
	afx_msg void OnGoForward();
	afx_msg void OnGoStop();
	afx_msg void OnGoRefresh();
	afx_msg void OnGoStartPage();
	afx_msg void OnGoSearchTheWeb();
	afx_msg void OnFileOpen();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnFilePrint();
	afx_msg void OnViewFontsLarge();
	afx_msg void OnViewFontsLargest();
	afx_msg void OnViewFontsMedium();
	afx_msg void OnViewFontsSmall();
	afx_msg void OnViewFontsSmallest();
	afx_msg void OnCoolestSite();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	afx_msg void OnStatusTextChange(LPCTSTR Text);
	afx_msg void OnProgressChange(long Progress, long ProgressMax);
	afx_msg void OnCommandStateChange(long Command, BOOL Enable);
	afx_msg void OnDownloadBegin();
	afx_msg void OnDownloadComplete();
	afx_msg void OnTitleChange(LPCTSTR lpszText);
	afx_msg void OnPropertyChange(LPCTSTR szProperty);
	afx_msg void OnBeforeNavigate2(LPDISPATCH pDisp, VARIANT FAR* URL, VARIANT FAR* Flags, VARIANT FAR* TargetFrameName, VARIANT FAR* PostData, VARIANT FAR* Headers, BOOL FAR* Cancel);
	afx_msg void OnNewWindow2(LPDISPATCH FAR* ppDisp, BOOL FAR* Cancel);
	afx_msg void OnNavigateComplete2(LPDISPATCH pDisp, VARIANT FAR* URL);
	afx_msg void OnDocumentComplete(LPDISPATCH pDisp, VARIANT FAR* URL);
	afx_msg void OnOnQuit();
	afx_msg void OnOnVisible(BOOL Visible);
	afx_msg void OnOnToolBar(BOOL ToolBar);
	afx_msg void OnOnMenuBar(BOOL MenuBar);
	afx_msg void OnOnStatusBar(BOOL StatusBar);
	afx_msg void OnOnFullScreen(BOOL FullScreen);
	afx_msg void OnOnTheaterMode(BOOL TheaterMode);
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in IEMozillaView.cpp
inline CIEMozillaDoc* CIEMozillaView::GetDocument()
   { return (CIEMozillaDoc*)m_pDocument; }
#endif


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_IEMOZILLAVIEW_H__7A739621_F300_11D1_9F48_C49E4E07811D__INCLUDED_)
