// MainFrm.cpp : implementation of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////
//
/**************************************************************
**        __                                          __
**     __/_/__________________________________________\_\__
**  __|_                                                  |__
** (___O)   William SerGio & Co., Inc.                   (O___)
**(_____O)	www.codearchive.com/~sergio			        (O_____)
**(_____O)	Author:	Bill SerGio, The Infomercial King   (O_____)
** (__O)	Author is listed in Who's Who in America     (O__)
**    |___________________________________________________|
****************************************************************/
/*
 * (C) Copyright 2002 by Bill SerGio, The Infomercial King.
 * All Rights Reserved Worldwide.
 * 20547 Old Cutler Road, PMB #222, Miami, FL 33189
 * www.codearchive.com/~sergio   sergio@codearchive.com  (305)233-9370
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted under this license for provided the following conditions are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Licensee does not utilize the software in a manner which is disparaging
 *    to the Author and/or any products or companies of the Author.
 * 4. This code/software may NOT be used in any way by any government,federal agency,
 *    or, any employee or agent of any government or federal agency. This software is
 *    not designed or intended for use in on-line control of aircraft, air traffic, 
 *    aircraft navigation or aircraft communications; or in design, construction, 
 *    operation or maintenance of any nuclear facility. Licensee represents and 
 *    warrants that it will not use or redistribute the Software for such purposes.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR FOR EDUCATIONAL PURPOSES ONLY,
 * 'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS,
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION),
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */


#include "stdafx.h"
#include "IEMozilla.h"
#include "IEMozillaView.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
    ON_WM_CREATE()
	ON_WM_COPYDATA()
	ON_COMMAND(ID_APP_EXIT, OnAppExit)
	ON_COMMAND(ID_APP_FREESTUFF, OnAppFreeStuff)
	ON_COMMAND(ID_APP_NEWVERSION, OnAppNewVersion)
	ON_COMMAND(ID_APP_PREFS, OnAppPrefs)
	ON_COMMAND(ID_DISABLE, OnDisable)
    ON_WM_SYSCOMMAND()
	ON_WM_DESTROY()
	ON_WM_CLOSE()
	ON_COMMAND(ID_APP_LAUNCH, OnAppLaunch)
	//}}AFX_MSG_MAP
	// Global help commands
	ON_COMMAND(ID_HELP_FINDER, CFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CFrameWnd::OnHelpFinder)
	ON_MESSAGE(WM_TRAYICON_NOTIFY, OnNotifyTrayIcon)
	ON_COMMAND_EX(ID_VIEW_FIELDCHOOSER, OnBarCheck)
	ON_UPDATE_COMMAND_UI(ID_VIEW_FIELDCHOOSER, OnUpdateControlBarMenu)
	ON_CBN_SELENDOK(AFX_IDW_TOOLBAR + 1,OnNewAddress)
	ON_COMMAND_RANGE(0xe00, 0xfff, OnFavorite)
	ON_COMMAND(IDOK, OnNewAddressEnter)
	ON_NOTIFY(TBN_DROPDOWN, AFX_IDW_TOOLBAR, OnDropDown)
	ON_COMMAND(ID_FAVORITES_DROPDOWN, DoNothing)
	ON_COMMAND(ID_FONT_DROPDOWN, DoNothing)
//	ON_COMMAND(ID_SAMPLE_DROPDOWN, DoNothing)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	CImageList img;
	CString str;

	if (!m_wndReBar.Create(this))
	{
		TRACE0("Failed to create rebar\n");
		return -1;      // fail to create
	}

	if (!m_wndToolBar.CreateEx(this))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
	// set up toolbar properties
	m_wndToolBar.GetToolBarCtrl().SetButtonWidth(30, 150);
	m_wndToolBar.GetToolBarCtrl().SetExtendedStyle(TBSTYLE_EX_DRAWDDARROWS);

	img.Create(IDB_HOTTOOLBAR, 22, 0, RGB(255, 0, 255));
	m_wndToolBar.GetToolBarCtrl().SetHotImageList(&img);
	img.Detach();
	img.Create(IDB_COLDTOOLBAR, 22, 0, RGB(255, 0, 255));
	m_wndToolBar.GetToolBarCtrl().SetImageList(&img);
	img.Detach();
	m_wndToolBar.ModifyStyle(0, TBSTYLE_FLAT | TBSTYLE_TRANSPARENT);
	m_wndToolBar.SetButtons(NULL, 9);

	// set up each toolbar button
	m_wndToolBar.SetButtonInfo(0, ID_GO_BACK, TBSTYLE_BUTTON, 0);
	str.LoadString(IDS_BACK);
	m_wndToolBar.SetButtonText(0, str);

	m_wndToolBar.SetButtonInfo(1, ID_GO_FORWARD, TBSTYLE_BUTTON, 1);
	str.LoadString(IDS_FORWARD);
	m_wndToolBar.SetButtonText(1, str);

	m_wndToolBar.SetButtonInfo(2, ID_GO_STOP, TBSTYLE_BUTTON, 2);
	str.LoadString(IDS_STOP);
	m_wndToolBar.SetButtonText(2, str);

	m_wndToolBar.SetButtonInfo(3, ID_GO_REFRESH, TBSTYLE_BUTTON, 3);
	str.LoadString(IDS_REFRESH);
	m_wndToolBar.SetButtonText(3, str);

	m_wndToolBar.SetButtonInfo(4, ID_GO_START_PAGE, TBSTYLE_BUTTON, 4);
	str.LoadString(IDS_HOME);
	m_wndToolBar.SetButtonText(4, str);

	m_wndToolBar.SetButtonInfo(5, ID_GO_SEARCH_THE_WEB, TBSTYLE_BUTTON, 5);
	str.LoadString(IDS_SEARCH);
	m_wndToolBar.SetButtonText(5, str);

	m_wndToolBar.SetButtonInfo(6, ID_FAVORITES_DROPDOWN, TBSTYLE_BUTTON | TBSTYLE_DROPDOWN, 6);
	str.LoadString(IDS_FAVORITES);
	m_wndToolBar.SetButtonText(6, str);

	m_wndToolBar.SetButtonInfo(7, ID_FILE_PRINT, TBSTYLE_BUTTON, 7);
	str.LoadString(IDS_PRINT);
	m_wndToolBar.SetButtonText(7, str);

	m_wndToolBar.SetButtonInfo(8, ID_COOLEST_SITE, TBSTYLE_BUTTON | TBSTYLE_DROPDOWN, 8);
	str.LoadString(IDS_COOLEST_SITE);
	m_wndToolBar.SetButtonText(8, str);

	//m_wndToolBar.SetButtonInfo(8, ID_FONT_DROPDOWN, TBSTYLE_BUTTON | TBSTYLE_DROPDOWN, 8);
	//str.LoadString(IDS_FONT);
	//m_wndToolBar.SetButtonText(8, str);

	CRect rectToolBar;

	// set up toolbar button sizes
	m_wndToolBar.GetItemRect(0, &rectToolBar);
	m_wndToolBar.SetSizes(rectToolBar.Size(), CSize(30,20));

	// create a combo box for the address bar
	if (!m_wndAddress.Create(CBS_DROPDOWN | WS_CHILD, CRect(0, 0, 200, 120), this, AFX_IDW_TOOLBAR + 1))
	{
		TRACE0("Failed to create combobox\n");
		return -1;      // fail to create
	}

	// create the animation control
	m_wndAnimate.Create(WS_CHILD | WS_VISIBLE, CRect(0, 0, 22, 22), this, AFX_IDW_TOOLBAR + 2);
	m_wndAnimate.Open(MOZILLA_AVI);

	// add the toolbar, animation, and address bar to the rebar    
	m_wndReBar.AddBar(&m_wndToolBar);
	//m_wndReBar.AddBar(&m_wndAnimate, NULL, NULL, RBBS_FIXEDSIZE | RBBS_FIXEDBMP);
	m_wndReBar.AddBar(&m_wndAnimate, NULL, NULL, RBBS_CHILDEDGE);
	str.LoadString(IDS_ADDRESS);
	m_wndReBar.AddBar(&m_wndAddress, str, NULL, RBBS_FIXEDBMP | RBBS_BREAK);

	// set up min/max sizes and ideal sizes for pieces of the rebar
	REBARBANDINFO rbbi;

	rbbi.cbSize = sizeof(rbbi);
	rbbi.fMask = RBBIM_CHILDSIZE | RBBIM_IDEALSIZE | RBBIM_SIZE;
	rbbi.cxMinChild = rectToolBar.Width();
	rbbi.cyMinChild = rectToolBar.Height();
	rbbi.cx = rbbi.cxIdeal = rectToolBar.Width() * 9;
	m_wndReBar.GetReBarCtrl().SetBandInfo(0, &rbbi);
	rbbi.cxMinChild = 0;

	CRect rectAddress;

	rbbi.fMask = RBBIM_CHILDSIZE | RBBIM_IDEALSIZE;
	m_wndAddress.GetEditCtrl()->GetWindowRect(&rectAddress);
	rbbi.cyMinChild = rectAddress.Height() + 10;
	rbbi.cxIdeal = 200;
	m_wndReBar.GetReBarCtrl().SetBandInfo(2, &rbbi);

	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_FIXED);

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// Set up Favorites menu
	TCHAR           sz[MAX_PATH];
	TCHAR           szPath[MAX_PATH];
	HKEY            hKey;
	DWORD           dwSize;
	CMenu*          pMenu;

	// First get rid of bogus submenu items.
	pMenu = GetMenu()->GetSubMenu(3);
	while(pMenu->DeleteMenu(0, MF_BYPOSITION));

	// Find out from the registry where the favorites are located.
	if(RegOpenKey(HKEY_CURRENT_USER, _T("Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\User Shell Folders"), &hKey) != ERROR_SUCCESS)
	{
		TRACE0("Favorites folder not found\n");
		return 0;
	}
	dwSize = sizeof(sz);
	RegQueryValueEx(hKey, _T("Favorites"), NULL, NULL, (LPBYTE)sz, &dwSize);
	ExpandEnvironmentStrings(sz, szPath, MAX_PATH);
	RegCloseKey(hKey);

	BuildFavoritesMenu(szPath, 0, pMenu);
	
	MoveWindow(0,0,GetSystemMetrics(SM_CXSCREEN),GetSystemMetrics(SM_CYSCREEN));

	HICON hIcon = ::LoadIcon(AfxGetResourceHandle(), MAKEINTRESOURCE(IDR_MAINFRAME));  // Icon to use

	// Install tray icon
	// Let's always start enabled!
	//
	if ( !InstallTrayIcon(TRUE) ) {
		return -1;
	}
	m_bTrayMenuDisplayed = FALSE;

	return 0;

}


BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
    TRACE("CMainFrame::PreCreateWindow\n");

    cs.lpszClass = szIEMozillaClassName;
    cs.style &= ~(LONG) FWS_ADDTOTITLE;

    if (!CFrameWnd::PreCreateWindow(cs))
        return FALSE;

    return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::SetEnable(BOOL bRet)
{
	g_Global.m_bEnable = bRet;
	m_pTrayStuff->SetIcon(bRet ? IDR_TRAY_ENABLE : IDR_TRAY_DISABLE);

}




BOOL CMainFrame::InstallTrayIcon(BOOL bEnable)
{
	// Called by APP after Init method of Mainframe....
	// this creates systemTray Class and calls Shell Api 
	// command to set app in systemTray...
	// If the SystemTray Create fails, it returns false to
	// App and which will not be launched....
	
	// PAY ATTENTION BRO! We have the OPPOSITE HERE!
	//
	g_Global.m_bEnable = bEnable;

	BOOL bTrayStuff = FALSE;
	m_pTrayStuff = new CTrayStuff();

	/**
	 * BILL SERGIO
	 * Since we are using only a 16x16, 16-color bitmap the image
	 * is anti-aliased by Shell_NotifyIcon().
	 * NEED TO TEST HOW IMAGE IS LOADED FOR BEST QUALITY
	 */
	//HICON hIcon = AfxGetApp()->LoadIcon(bEnable ? IDI_TRAY_ENABLE : IDI_TRAY_DISABLE);
	bTrayStuff = m_pTrayStuff->Create(this, 
							WM_TRAYICON_NOTIFY, 
							"IEMozilla",
							AfxGetApp()->LoadIcon(g_Global.m_bEnable ? IDR_TRAY_ENABLE : IDR_TRAY_DISABLE), 
							IDR_TRAY_MENU);


	BOOL bInitializeFlag = TRUE;
	if ( bTrayStuff ) {
		if ( !bEnable ) {
  			ShowWindow(SW_MINIMIZE);
 			ShowWindow(SW_HIDE);
// 			GetTaskBarPosition();
		}
	}

	return bTrayStuff;
 
}




void CMainFrame::OnDisable() 
{
	g_Global.m_bEnable = !g_Global.m_bEnable;

	SetEnable(g_Global.m_bEnable);

}



LRESULT CMainFrame::OnNotifyTrayIcon(WPARAM wParam, LPARAM lParam)
{
	UINT uID       = (UINT)wParam;
	UINT uMouseMsg = (UINT)lParam;

	CRect client;
	GetClientRect(&client);
		
	//if (uID != IDR_MAINFRAME) return 0L;

	switch(uMouseMsg)
	{
		case WM_LBUTTONDOWN:
		{
			if ( g_Global.m_bEnable ) {
				//StartTracking(TRUE, CPoint(0,0));
				//m_pTrayStuff->SetIconList(IDI_ICON1, IDI_ICON4);
				//Animate(6, 10);
			}
			break;
		}
		case WM_LBUTTONDBLCLK :
		{
			// We are using a HIDDEN MainFrame for Skins!!!!
			//SetForegroundWindow(m_hWnd);  
			//ShowWindow(SW_SHOWNORMAL);
			break;
		}

		case WM_RBUTTONDOWN :
		{
			if (!m_bTrayMenuDisplayed)
			{
				m_bTrayMenuDisplayed = TRUE;
				//m_pMainDlg->ShowWindow(SW_HIDE);

				CMenu cTaskBarDummyMenu;
				if (!cTaskBarDummyMenu.LoadMenu(IDR_TRAY_MENU)) return 0L;
				CMenu* pcTaskBarMenu = cTaskBarDummyMenu.GetSubMenu(0);
			
				SetMenuDefaultItem(pcTaskBarMenu->GetSafeHmenu(), ID_APP_LAUNCH, FALSE);

				int i = 0;
				CString str;
				if (!g_Global.m_bEnable)
				{
					pcTaskBarMenu->CheckMenuItem(ID_DISABLE, MF_CHECKED);
					pcTaskBarMenu->ModifyMenu(ID_APP_ABOUT,MF_BYCOMMAND | MF_GRAYED,0,"&About IEMozilla");
					pcTaskBarMenu->ModifyMenu(ID_APP_LAUNCH,MF_BYCOMMAND | MF_GRAYED,0,"&IEMozilla");
					pcTaskBarMenu->ModifyMenu(ID_APP_PREFS,MF_BYCOMMAND | MF_GRAYED,0,"&Options");
				}
				else {
					pcTaskBarMenu->CheckMenuItem(ID_DISABLE, MF_UNCHECKED);
					pcTaskBarMenu->EnableMenuItem(ID_APP_ABOUT,MF_BYCOMMAND);
					pcTaskBarMenu->EnableMenuItem(ID_APP_LAUNCH,MF_BYCOMMAND);
					pcTaskBarMenu->EnableMenuItem(ID_APP_PREFS,MF_BYCOMMAND);
				}


				CPoint ptCursor;
				GetCursorPos(&ptCursor);

				int nRetValue = GetTaskBarPosition();
				if (nRetValue = 3 ){
					m_nMenuRight = ptCursor.x;
					//m_nMenuBottom = ptCursor.y;
				}

				this->SetForegroundWindow(); 
				//if (pcTaskBarMenu)
				//{
					pcTaskBarMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON, ptCursor.x, ptCursor.y, this, NULL);
				//}
				PostMessage(NULL,0,0);
				cTaskBarDummyMenu.DestroyMenu();
				m_bTrayMenuDisplayed = FALSE;
			}
		}
		break;
	}

	return 0L;
}



void CMainFrame::AnimateTrayIcon()
{
	//m_pTrayStuff->SetIconList(IDI_ICON1, IDI_ICON4);
	//Animate(69, 6);
}



void CMainFrame::OnTimer(UINT nIDEvent) 
{
	switch( nIDEvent ) 
	{
		case ID_TIMER_ANIMATE_TRAY:
			COleDateTime CurrentTime = COleDateTime::GetCurrentTime();
			COleDateTimeSpan period = CurrentTime - m_StartTime;
			if ( (m_nAnimationPeriod > 0)
				&& (m_nAnimationPeriod < period.GetTotalSeconds()) )
			{
				StopAnimation();
				return;
			}
			m_pTrayStuff->StepAnimation();
			break;
	}

	CFrameWnd::OnTimer(nIDEvent);

}




BOOL CMainFrame::StopAnimation()
{
    BOOL bResult = FALSE;

    bResult = KillTimer(ID_TIMER_ANIMATE_TRAY);

	HICON hIcon = ::LoadIcon(AfxGetResourceHandle(), MAKEINTRESOURCE(IDR_MAINFRAME));  // Icon to use

    //if (m_hSavedIcon)
        m_pTrayStuff->SetIcon(hIcon);

    m_hSavedIcon = NULL;

    return bResult;
}



BOOL CMainFrame::Animate(UINT nDelayMilliSeconds, int nNumSeconds /*=-1*/)
{
    StopAnimation();

    m_pTrayStuff->m_nCurrentIcon = 0;
    m_StartTime = COleDateTime::GetCurrentTime();
    m_nAnimationPeriod = nNumSeconds;
    m_hSavedIcon = m_pTrayStuff->GetIcon();

	SetTimer(ID_TIMER_ANIMATE_TRAY, nDelayMilliSeconds, NULL);

    return TRUE;
}


// --------------------------------------------------------------------------
// GetTaskBarPosition : retrieve rectangle coordinates of taskbar window.
// AUTHOR: BILL SERGIO
// Returns -1 : if en error occured
//          0 : if taskbar is at the left of the screen
//          1 : if taskbar is at the top of the screen
//          2 : if taskbar is at the right of the screen
//          3 : if taskbar is at the bottom of the screen
// MainFrm.cpp
// --------------------------------------------------------------------------
int CMainFrame::GetTaskBarPosition(RECT *pstRect)
{
    HWND hTaskBarWnd = NULL;
    HWND hTrayWnd = NULL;
    HWND hClockWnd = NULL;

	m_rcTaskBar.left = 0;
	m_rcTaskBar.top = 0;
	m_rcTaskBar.right = 0;
	m_rcTaskBar.bottom = 0;

	m_nMenuBottom = GetSystemMetrics(SM_CYSCREEN)-10;
	m_nMenuRight = GetSystemMetrics(SM_CXSCREEN)-50;


	// Get rectangle coordinates of the taskbar
	APPBARDATA stABD;

	stABD.cbSize = sizeof(stABD);
	stABD.hWnd   = 0;

	BOOL bRet = (BOOL)SHAppBarMessage(ABM_GETTASKBARPOS, &stABD);

	if (bRet == FALSE) return -1;

	int iRet = 1;

	//char lbuffer[20];
	//AfxMessageBox(_ltoa( stABD.rc.top, lbuffer, 10 ));

	// Get position of status bar icon.
	if ((stABD.rc.left < GetSystemMetrics(SM_CXSCREEN) / 2)
		&& (stABD.rc.top > GetSystemMetrics(SM_CYSCREEN) / 2))
	{
		m_nMenuBottom = stABD.rc.top;
		iRet = 3;

		hTaskBarWnd = ::FindWindow("Shell_TrayWnd", NULL);
		if ( hTaskBarWnd )
		{
			// Find Tray
			hTrayWnd = ::FindWindowEx(hTaskBarWnd, 0, "TrayNotifyWnd", NULL);
			if ( hTrayWnd )
			{
				// Find Clock
				hClockWnd = ::FindWindowEx(hTrayWnd, 0, "TrayClockWClass", NULL);
				RECT rcClock;
				::GetWindowRect(hClockWnd, &rcClock);
				m_nMenuRight = rcClock.left;
			}
		}
	
	}
	else if ((stABD.rc.left > GetSystemMetrics(SM_CXSCREEN) / 2) 
		&& (stABD.rc.top < GetSystemMetrics(SM_CYSCREEN) / 2))
	{
		iRet = 2;
	}
	else if ((stABD.rc.left < GetSystemMetrics(SM_CXSCREEN) / 2) 
		&& (stABD.rc.top < GetSystemMetrics(SM_CYSCREEN) / 2) 
		&& (stABD.rc.right < GetSystemMetrics(SM_CXSCREEN) / 2)) 
	{
		iRet = 0;
	}
	else iRet = 1;

	if (pstRect) memcpy(pstRect, &stABD.rc, sizeof(RECT));

	m_rcTaskBar.left = stABD.rc.left;
	m_rcTaskBar.top = stABD.rc.top;
	m_rcTaskBar.right = stABD.rc.right;
	m_rcTaskBar.bottom = stABD.rc.bottom;

	m_nTaskBarPos = iRet;

	return iRet;
}


void CMainFrame::OnAppExit() 
{
	// TODO: Add your command handler code here
	m_pTrayStuff->RemoveIcon();
    // Same as double-clicking on main window close box.
    ASSERT(AfxGetApp()->m_pMainWnd != NULL);
    AfxGetApp()->m_pMainWnd->SendMessage(WM_CLOSE);

	::Sleep(0);
	// If we get here, we couldn't close after all and we
	// do it our-selves
	AfxWinTerm();
	exit(0);
}

void CMainFrame::OnAppFreeStuff() 
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnAppNewVersion() 
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnAppPrefs() 
{
	// TODO: Add your command handler code here
	
}

/*
COLOR_ACTIVEBORDER
COLOR_ACTIVECAPTION
COLOR_APPWORKSPACE
COLOR_BACKGROUND
COLOR_BTNFACE
COLOR_BTNSHADOW
COLOR_BTNTEXT
COLOR_CAPTIONTEXT
COLOR_GRAYTEXT
COLOR_HIGHLIGHT
COLOR_HIGHLIGHTTEXT
COLOR_INACTIVEBORDER
COLOR_INACTIVECAPTION
COLOR_MENU
COLOR_MENUTEXT
COLOR_SCROLLBAR
COLOR_WINDOW
COLOR_WINDOWFRAME
COLOR_WINDOWTEXT 
*/


int CMainFrame::BuildFavoritesMenu(LPCTSTR pszPath, int nStartPos, CMenu* pMenu)
{
	CString         strPath(pszPath);
	CString         strPath2;
	CString         str;
	WIN32_FIND_DATA wfd;
	HANDLE          h;
	int             nPos;
	int             nEndPos;
	int             nNewEndPos;
	int             nLastDir;
	TCHAR           buf[INTERNET_MAX_PATH_LENGTH];
	CStringArray    astrFavorites;
	CStringArray    astrDirs;
	CMenu*          pSubMenu;

	// make sure there's a trailing backslash
	if(strPath[strPath.GetLength() - 1] != _T('\\'))
		strPath += _T('\\');
	strPath2 = strPath;
	strPath += "*.*";

	// now scan the directory, first for .URL files and then for subdirectories
	// that may also contain .URL files
	h = FindFirstFile(strPath, &wfd);
	if(h != INVALID_HANDLE_VALUE)
	{
		nEndPos = nStartPos;
		do
		{
			if((wfd.dwFileAttributes & (FILE_ATTRIBUTE_DIRECTORY|FILE_ATTRIBUTE_HIDDEN|FILE_ATTRIBUTE_SYSTEM))==0)
			{
				str = wfd.cFileName;
				if(str.Right(4) == _T(".url"))
				{
					// an .URL file is formatted just like an .INI file, so we can
					// use GetPrivateProfileString() to get the information we want
					::GetPrivateProfileString(_T("InternetShortcut"), _T("URL"),
											  _T(""), buf, INTERNET_MAX_PATH_LENGTH,
											  strPath2 + str);
					str = str.Left(str.GetLength() - 4);

					// scan through the array and perform an insertion sort
					// to make sure the menu ends up in alphabetic order
					for(nPos = nStartPos ; nPos < nEndPos ; ++nPos)
					{
						if(str.CompareNoCase(astrFavorites[nPos]) < 0)
							break;
					}
					astrFavorites.InsertAt(nPos, str);
					m_astrFavoriteURLs.InsertAt(nPos, buf);
					++nEndPos;
				}
			}
		} while(FindNextFile(h, &wfd));
		FindClose(h);
		// Now add these items to the menu
		for(nPos = nStartPos ; nPos < nEndPos ; ++nPos)
		{
			pMenu->AppendMenu(MF_STRING | MF_ENABLED, 0xe00 + nPos, astrFavorites[nPos]);
		}


		// now that we've got all the .URL files, check the subdirectories for more
		nLastDir = 0;
		h = FindFirstFile(strPath, &wfd);
		ASSERT(h != INVALID_HANDLE_VALUE);
		do
		{
			if(wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
			{
				// ignore the current and parent directory entries
				if(lstrcmp(wfd.cFileName, _T(".")) == 0 || lstrcmp(wfd.cFileName, _T("..")) == 0)
					continue;

				for(nPos = 0 ; nPos < nLastDir ; ++nPos)
				{
					if(astrDirs[nPos].CompareNoCase(wfd.cFileName) > 0)
						break;
				}
				pSubMenu = new CMenu;
				pSubMenu->CreatePopupMenu();

				// call this function recursively.
				nNewEndPos = BuildFavoritesMenu(strPath2 + wfd.cFileName, nEndPos, pSubMenu);
				if(nNewEndPos != nEndPos)
				{
					// only intert a submenu if there are in fact .URL files in the subdirectory
					nEndPos = nNewEndPos;
					pMenu->InsertMenu(nPos, MF_BYPOSITION | MF_POPUP | MF_STRING, (UINT)pSubMenu->m_hMenu, wfd.cFileName);
					pSubMenu->Detach();
					astrDirs.InsertAt(nPos, wfd.cFileName);
					++nLastDir;
				}
				delete pSubMenu;
			}
		} while(FindNextFile(h, &wfd));
		FindClose(h);
	}
	return nEndPos;
}

void CMainFrame::OnFavorite(UINT nID)
{
	((CIEMozillaView*)GetActiveView())->LoadBrowser(m_astrFavoriteURLs[nID-0xe00]);
}

void CMainFrame::SetAddress(LPCTSTR lpszUrl)
{
	// This is called when the browser has completely loaded the new location,
	// so make sure the text in the address bar is up to date and stop the
	// animation.

	AfxGetMainWnd()->SetWindowText ( "Bill SerGio's Mozilla Browser" );
	m_wndAddress.SetWindowText(lpszUrl);
	m_wndAnimate.Stop();
	m_wndAnimate.Seek(0);

}

void CMainFrame::StartAnimation()
{
	// Start the animation.  This is called when the browser begins to
	// navigate to a new location
	m_wndAnimate.Play(0, -1, -1);
}

void CMainFrame::OnNewAddress()
{
	// gets called when an item in the Address combo box is selected
	// just navigate to the newly selected location.
	CString str;
	m_wndAddress.GetLBText(m_wndAddress.GetCurSel(), str);
	//((CWBView*)GetActiveView())->Navigate2(str, 0, NULL);
//	((CWBView*)(CView*) m_wndSplitter.GetPane(0, 1))->Navigate2(str, 0, NULL);
//	((CWBView*)m_pSplitterWnd->GetPane(0, 1))->Navigate2(str, 0, NULL);

}


void CMainFrame::DoNothing()
{
	// this is here only so that the toolbar buttons for the dropdown menus
	// will have a callback, and thus will not be disabled.
}

void CMainFrame::OnDropDown(NMHDR* pNotifyStruct, LRESULT* pResult)
{
	// this function handles the dropdown menus from the toolbar
	NMTOOLBAR* pNMToolBar = (NMTOOLBAR*)pNotifyStruct;
	CRect rect;

	// translate the current toolbar item rectangle into screen coordinates
	// so that we'll know where to pop up the menu
	m_wndToolBar.GetToolBarCtrl().GetRect(pNMToolBar->iItem, &rect);
	rect.top = rect.bottom;
	::ClientToScreen(pNMToolBar->hdr.hwndFrom, &rect.TopLeft());
	/*
	if(pNMToolBar->iItem == ID_FONT_DROPDOWN)
	{
		CMenu menu;
		CMenu* pPopup;

		// the font popup is stored in a resource
		menu.LoadMenu(IDR_FONT_POPUP);
		pPopup = menu.GetSubMenu(0);
		pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON, rect.left, rect.top + 1, AfxGetMainWnd());

	
	}
	*/
	if(pNMToolBar->iItem == ID_COOLEST_SITE)
	{
		CMenu menu;
		CMenu* pPopup;

		// the font popup is stored in a resource
		menu.LoadMenu(IDR_COOL);
		pPopup = menu.GetSubMenu(0);
		pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON, rect.left, rect.top + 1, AfxGetMainWnd());

	
	}
	else if(pNMToolBar->iItem == ID_APP_DROPDOWN)
	{
		CMenu menu;
		CMenu* pPopup;

		menu.LoadMenu(IDR_MAIN_POPUP);
		pPopup = menu.GetSubMenu(0);
		pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON, rect.left, rect.top + 1, AfxGetMainWnd());
	}
	else if(pNMToolBar->iItem == ID_FAVORITES_DROPDOWN)
	{
		CMenu* pPopup;

		// for the favorties popup, just steal the menu from the main window
		pPopup = GetMenu()->GetSubMenu(3);
		pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON, rect.left, rect.top + 1, AfxGetMainWnd());
	}
	*pResult = TBDDRET_DEFAULT;
}


void CMainFrame::OnAppLaunch() 
{
    ASSERT(AfxGetApp()->m_pMainWnd != NULL);
    AfxGetApp()->m_pMainWnd->ShowWindow(SW_SHOWMAXIMIZED);
	
}



void CMainFrame::OnNewAddressEnter()
{
	// gets called when an item is entered manually into the edit box portion
	// of the Address combo box.
	// navigate to the newly selected location and also add this address to the
	// list of addresses in the combo box.
	CString csUrl;

	m_wndAddress.GetEditCtrl()->GetWindowText(csUrl);

	((CIEMozillaView*)GetActiveView())->LoadBrowser(csUrl);

	COMBOBOXEXITEM item;

	item.mask = CBEIF_TEXT;
	item.iItem = -1;
	item.pszText = (LPTSTR)(LPCTSTR)csUrl;
	m_wndAddress.InsertItem(&item);
}



CString CMainFrame::ResourceToURL(LPCTSTR lpszURL)
{
	// This functions shows how to convert an URL to point
	// within the application
	// I only use it once to get the startup page

	CString m_strURL;
	HINSTANCE hInstance = AfxGetResourceHandle();
	ASSERT(hInstance != NULL);
	
	LPTSTR lpszModule = new TCHAR[_MAX_PATH];
	
	if (GetModuleFileName(hInstance, lpszModule, _MAX_PATH))
	{
		m_strURL.Format(_T("res://%s/%s"), lpszModule, lpszURL);
	}
	
	delete []lpszModule;

	return m_strURL;
}




void CMainFrame::OnSysCommand(UINT nID, LPARAM lParam)
{
    TRACE("CMainFrame::OnSysCommand\n");

    //CIEMozillaDoc *pDoc = static_cast<CIEMozillaDoc*>(static_cast<CIEMozillaApp*>(AfxGetApp())->m_pDoc);
    //ASSERT(AfxIsValidAddress(pDoc, sizeof(CIEMozillaDoc)));

    try
    {
        if (nID == SC_MINIMIZE)
        {
            //if (!pDoc->m_bNoTrayIcon || pDoc->m_bHideOnMinimize)
            //{
                ShowWindow(SW_HIDE);
                return;
            //}
        }
    }
    catch ( ... ) {}

    CFrameWnd::OnSysCommand(nID, lParam);
}


void CMainFrame::OnDestroy() 
{
    TRACE("CMainFrame::OnDestroy\n");

    CIEMozillaDoc *pDoc = static_cast<CIEMozillaDoc*>(static_cast<CIEMozillaApp*>(AfxGetApp())->m_pDoc);
    ASSERT(AfxIsValidAddress(pDoc, sizeof(CIEMozillaDoc)));

    try
    {
        SetActiveView(NULL, FALSE);
        CFrameWnd::OnDestroy();
    }
    catch ( ... ) {}

}

void CMainFrame::OnClose() 
{
	// Only allow exit from App by menu!
	//
    ASSERT(AfxGetApp()->m_pMainWnd != NULL);
    AfxGetApp()->m_pMainWnd->ShowWindow(SW_HIDE);

	//CFrameWnd::OnClose();
}
